<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2003 Administrator (admin@email.test)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'SourceOptimization' for the 'SourceOpt' extension.
 *
 * @author	Boris Nicolai <boris.nicolai@andavida.com>
 */

require_once(PATH_tslib."class.tslib_pibase.php");

class tx_sourceopt_pi1 extends tslib_pibase {
	
	var $prefixId = "tx_sourceopt_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_sourceopt_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "sourceopt";	// The extension key.
	
	/**
	 * [Put your description here]
	 */
	function main (&$content, &$conf)
	{
		$this->content =& $content;
		$this->conf =& $conf;
		
#debug ($conf, 1);
		
		// set filename & path for css-file
		if (!$this->conf['move_inline_css_file'])
		{
			$this->conf['move_inline_css_file'] = 'fileadmin/so.css';
		}
		$this->conf['move_inline_css_file'] = $this->conf['move_inline_css_file'];
		
		// set newline
		switch (TYPO3_OS)
		{
			case "WIN" : $this->newline = "\r\n"; break;
			default : $this->newline = "\n";
		}
		
#debug (array ($this->content), 1);
		
		// switch through wished modifications; sorting should not e changed
		if ($conf['enabled'] == 1)
		{
			if (!empty ($conf['replace_doctype']))
			{
				$this->replaceDoctype ();
			}
			if (!empty ($conf['replace_clear_gif']))
			{
				$this->replaceClearGif ();
			}
			if ($conf['remove_generator'] == 1)
			{
				$this->removeGenerator ();
			}
			if ($conf['remove_link_schema'] == 1)
			{
				$this->removeLinkSchema ();
			}
			if ($conf['remove_script_cdata'] == 1)
			{
				$this->removeScriptCdata ();
			}
			if ($conf['move_inline_css'] == 1)
			{
				$this->moveInlineCss ();
			}
			if ($conf['remove_blur_script'] == 1)
			{
				$this->removeBlurScript ();
			}
			if ($conf['emtpy_body_tag'] == 1)
			{
				$this->emtpyBodyTag ();
			}
			
			if ($conf['remove_comments'] == 1)
			{
				$this->removeComments ();
			}
			if ($conf['remove_empty_alt_atr'] == 1)
			{
				$this->removeEmptyAltAtr ();
			}
			
			
			if ($conf['remove_tabs'] == 1)
			{
				$this->removeTabs (&$this->content);
			}
			if ($conf['trim_lines'] == 1)
			{
				$this->trimLines (&$this->content);
			}
			if ($conf['remove_empty_lines'] == 1)
			{
				$this->removeEmptyLines (&$this->content);
			}
			
#debug (array ($this->content), 1);
			
			if ($conf['remove_new_lines'] == 1)
			{
				$this->removeNewLines (&$this->content);
			}
		}
	}


	function replaceDoctype ()
	{
		$this->content = preg_replace ("/<!DOCTYPE.+?>/is", $this->conf['replace_doctype'], $this->content);
	}


	function replaceClearGif ()
	{
		$this->content = str_replace ("clear.gif", $this->conf['replace_clear_gif'], $this->content);
	}


	function removeGenerator ()
	{
		$this->content = preg_replace ("/<meta name=\"?generator\"?.+?>/is", "", $this->content);
	}


	function removeLinkSchema ()
	{
		$this->content = preg_replace ("/<link rel=\"?schema.dc\"?.+?>/is", "", $this->content);
	}


	function removeScriptCdata ()
	{
		$pattern = "/<script type=\"text\/javascript\">.+CDATA.+<\/script>/is";
		$this->content = preg_replace ($pattern, "", $this->content);
	}



	function removeEmptyAltAtr ()
	{
		$this->content = str_replace ("alt=\"\"", "", $this->content);
	}

	/**
	* Typo adds to each page a small script: 
	*		<script language="javascript">
	*		<!--
	*		browserName = navigator.appName;
	*		browserVer = parseInt(navigator.appVersion);
	*		var msie4 = (browserName == "Microsoft Internet Explorer" && browserVer >= 4);
	*		if ((browserName == "Netscape" && browserVer >= 3) || msie4 || browserName=="Konqueror") {version = "n3";} else {version = "n2";}
	*		function blurLink(theObject){
	*		if (msie4){theObject.blur();}
	*		}
	*		// -->
	*		</script>
	* Obviously used for client-side browserdetection - but thats not necessary if your page doesn't use JS
	*/
	function removeBlurScript ()
	{
		#$pattern = "/<script language=\"javascript\">.+?Konqueror.+function blurLink.+theObject.blur.+?<\/script>/im";
		$pattern = "/<script (type=\"text\/javascript\"|language=\"javascript\")>.+?Konqueror.+function blurLink.+theObject.blur.+?<\/script>/is";
			// used a REX instead of str_replace cause str_replace didn't work reliably
		$this->content = preg_replace ($pattern, "", $this->content);
		$this->content = str_replace (" onFocus=\"blurLink(this);\"", "", $this->content);
		$this->content = str_replace (" onfocus=\"blurLink(this);\"", "", $this->content);
	}



	/**
	* remove all attributes from the body-tag
	*/
	function emtpyBodyTag ()
	{
		$this->content = preg_replace ("/<body.+?>/i", "<body>", $this->content);
	}


	/**
	* clean up html-comments
	*/
	function removeComments ()
	{
		$this->content = preg_replace ("/<!--.+?-->/is", "", $this->content);
		
		if ($this->conf['keep_typo3_copyright'] == 1)
		{
			$replacement = "<head>\n<!--\n\tThis website is brought to you by TYPO3 - get.content.right\n\tTYPO3 is a free open source Content Management Framework\n\tcreated by Kasper Skaarhoej and licensed under GNU/GPL.\n\tInformation and contribution at http://www.typo3.com\n-->";
			
			$this->content = str_replace ("<head>", $replacement, $this->content);
		}
	}


	/**
	* get all css from the current document, move it all into an external file and do some optimization to the file
	*/
	function moveInlineCss ()
	{
			// check, if directory exists
		$path_parts = pathinfo ($this->conf['move_inline_css_file']);
		if (!is_dir (PATH_site.$path_parts['dirname']))
		{
			debug (array ('The directory "'.$path_parts['dirname'].'" specified for the inline-css-file doesn\'t exist (extension source-optimization)'));
		}
		else
		{
				// get all inline-css
			$num_00 = preg_match_all ("/<style.+?>.+<\/style>/is", $this->content, $matches);
			
				// if there are any reasults, try to open/create the css-file and insert the optimized css into this file
			if ($num_00)
			{
				if (count ($matches[0]) > 1)
				{
					$css_content_new = implode ($this->newline, $matches[0]);
				}
				else
				{
					$css_content_new = $matches[0][0];
				}
				
					// remove style-tags, html-comments and css-comments
				$css_content_new = preg_replace ("/<\/style>/i", "", $css_content_new);
				$css_content_new = preg_replace ("/<style.+?>/i", "", $css_content_new);
				$css_content_new = str_replace ("<!--", "", $css_content_new);
				$css_content_new = str_replace ("-->", "", $css_content_new);
				$css_content_new = preg_replace ("/\/\*.+?\*\//is", "", $css_content_new);
				
	#debug (array ($css_content_new), 1);
				
					// optimization of the css
				$this->removeTabs (&$css_content_new);
				$this->trimLines (&$css_content_new);
				$this->removeEmptyLines (&$css_content_new);
				$this->removeNewLines (&$css_content_new);
				
	#debug (array ($css_content_new), 1);
				
					// check, if the css-file already exists: if so, compare the css with the new css and write it if any
					// chances and of course if no file exists; if they are the same, don't do anything
				if (!file_exists (PATH_site.$this->conf['move_inline_css_file']))
				{
					$handle = fopen (PATH_site.$this->conf['move_inline_css_file'], "w+");
					fwrite ($handle, $css_content_new);
					fclose ($handle);
				}
				else if (file_exists (PATH_site.$this->conf['move_inline_css_file']))
				{
					$handle = fopen (PATH_site.$this->conf['move_inline_css_file'], "r");
					if ($handle)
					{
						$file_content = fread ($handle, filesize (PATH_site.$this->conf['move_inline_css_file']));
						if ($file_content != $css_content_new)
						{
							$handle_w = fopen (PATH_site.$this->conf['move_inline_css_file'], "w");
							fwrite ($handle_w, $css_content_new);
							fclose ($handle_w);
						}
					}
					fclose ($handle);
				}
				
					// replace css in source with path to css-file
				$css_path = 'http://'.t3lib_div::getThisUrl ().$this->conf['move_inline_css_file'];
				$css_link = '<link rel="stylesheet" href="'.$css_path.'" />';
				$this->content = preg_replace ("/<style.+?>.+<\/style>/is", $css_link, $this->content, 1);
				$this->content = preg_replace ("/<style.+?>.+<\/style>/is", "", $this->content);
			}
		}
	}


	function removeTabs (&$body)
	{
		$body = str_replace ("\t", "", $body);
	}


	function trimLines (&$body)
	{
		// convert newlines according to the current OS
		if (TYPO3_OS == "WIN")
		{
			$body = str_replace ("\r\n", "\n", $body);
			$body = str_replace ("\n", "\r\n", $body);
		}
		else
		{
			$body = str_replace ("\r\n", "\n", $body);
		}
		
		$temp = explode ($this->newline, $body);
		array_walk ($temp, array('tx_sourceopt_pi1', 'trimLines_callback') );
		$body = implode ($this->newline, $temp);
		unset ($temp);
	}


	function trimLines_callback (&$value, $key)
	{
		$value = trim ($value);
	}


	function removeEmptyLines (&$body)
	{
		// convert newlines according to the current OS
		if (TYPO3_OS == "WIN")
		{
			$body = str_replace ("\r\n", "\n", $body);
			$body = str_replace ("\n", "\r\n", $body);
		}
		else
		{
			$body = str_replace ("\r\n", "\n", $body);
		}
		
		// we do two loops cause with only loop stay some empty lines
		// no idea why
		
		$temp = explode ($this->newline, $body);
		for ($i = 0; $i < count ($temp); $i++)
		{
			if (!$temp[$i])
			{
				unset ($temp[$i]);
			}
		}
		$body = implode ($this->newline, $temp);
		
		$temp = explode ($this->newline, $body);
		for ($i = 0; $i < count ($temp); $i++)
		{
			if (!$temp[$i])
			{
				unset ($temp[$i]);
			}
		}
		$body = implode ($this->newline, $temp);
		
		unset ($temp);
	}


	function removeNewLines (&$body)
	{
		$body = str_replace ("\r\n", " ", $body);
		$body = str_replace ("\n", " ", $body);
	}

}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/SourceOpt/pi1/class.tx_SourceOpt_pi1.php"])
{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/SourceOpt/pi1/class.tx_SourceOpt_pi1.php"]);
}

?>